<?php
//
// Copyright (c) 2008-2009 Nagios Enterprises, LLC.  All rights reserved.
//
// $Id: testemail.php 2806 2014-07-11 15:57:43Z swilkerson $

require_once(dirname(__FILE__) . '/../includes/common.inc.php');

// initialization stuff
pre_init();

// start session
init_session();

// grab GET or POST variables 
grab_request_vars();

// check prereqs
check_prereqs();

// check authentication
check_authentication();


// route request
route_request();


function route_request()
{
    global $request;

    if (isset($request['update']))
        do_test();
    else
        show_test();
    exit;
}


/**
 * @param bool   $error
 * @param string $msg
 */
function show_test($error = false, $msg = "")
{
    global $lstr;


    do_page_start(array("page_title" => $lstr['EmailTestPageTitle']), true);
    ?>

    <h1><?php echo $lstr['EmailTestPageHeader']; ?></h1>


    <?php
    display_message($error, false, $msg);
    ?>

    <?php echo $lstr['EmailTestPageMessage']; ?>

    <form method="post" action="">
        <input type="hidden" name="update" value="1"/>

        <?php

        // get user's email
        $email = get_user_attr(0, "email");

        ?>

        <p>
            <?php echo gettext("An email will be sent to"); ?>: <b><?php echo $email; ?></b>
        </p>

        <p>
            <a href="<?php echo get_base_url() . "account/?xiwindow=main.php"; ?>"
               target="_top"><b><?php echo gettext("Change your email address"); ?></b></a>
        </p>


        <div id="formButtons">
            <input type="submit" class="submitbutton" name="updateButton"
                   value="<?php echo $lstr['SendTestEmailButton']; ?>" id="updateButton"/>
        </div>

    </form>

    <?php

    do_page_end(true);
    exit();
}


/**
 * @return array
 */
function do_test()
{
    global $lstr;

    // demo mode
    if (in_demo_mode() == true)
        show_test(true, $lstr['DemoModeChangeError']);

    // grab variables
    $email = grab_request_var("email", "");

    $test_email = true;

    $output = array();

    // get the admin email
    $admin_email = get_option("admin_email");

    // get the user's email address
    if ($email == "")
        $email = get_user_attr(0, "email");

    // send a test email notification
    if ($test_email == true) {

        // get the email subject and message
        $subject = "Nagios XI Email Test";
        $message = gettext("This is a test email from Nagios XI");

        $opts = array(
            "from" => "Nagios XI <" . $admin_email . ">",
            "to" => $email,
            "subject" => $subject,
        );
        $opts["message"] = $message;
        $result = send_email($opts, $debugmsg);

        $opts["debug"] = true;

        $output[] = gettext("A test email was sent to ") . "<b>" . $email . "</b>";
        $output[] = "----";

        $output[] = gettext("Mailer said") . ": <b>" . $debugmsg . "</b>";

        // check for errors
        if ($result == false) {
            $output[] = gettext("An error occurred sending a test email!");
            show_test(true, $output);
        }
    }


    show_test(false, $output);
    return $output;
}


?>